<template>
  <div>
    <DefaultHeaderPage>
      <template #after>
        <q-btn
          color="primary"
          padding="8px 8px"
          :label="$t('common.actions.add')"
          icon="mdi-plus"
          class="q-mt-md"
          @click="onAddItem"
        />
      </template>
    </DefaultHeaderPage>
    <div>
      <DefaultTable
        ref="tableRef"
        :columns="columns"
        :api-call="getStates"
        :delete-function="deleteState"
        :show-columns-select="false"
        :title="
          $t('common.terms.list') +
          ' ' +
          $t('common.ui.table.of') +
          ' ' +
          $t('ui.navigation.state')
        "
      >
        <template #body-cell-actions="{ row }">
          <q-btn
            outline
            style="width: 36px"
            class="q-ml-auto q-mr-sm"
            @click.prevent.stop="onRowClick(row)"
          >
            <q-icon name="mdi-file-edit-outline" />
          </q-btn>
        </template>
      </DefaultTable>
    </div>
  </div>
</template>
<script setup>
import { defineAsyncComponent, useTemplateRef } from "vue";
import { useQuasar } from "quasar";
import { useI18n } from "vue-i18n";
import { permissionStore } from "src/stores/permission";
import { getStates, deleteState } from "src/api/state";

import DefaultTable from "src/components/defaults/DefaultTable.vue";
import DefaultHeaderPage from "src/components/layout/DefaultHeaderPage.vue";

const AddEditStateDialog = defineAsyncComponent(
  () => import("src/pages/state/components/AddEditStateDialog.vue"),
);

const permission_store = permissionStore();
const $q = useQuasar();
const tableRef = useTemplateRef("tableRef");
const { t } = useI18n();

const columns = [
  {
    name: "id",
    label: "ID",
    field: "id",
    align: "left",
    required: true,
    sortable: true,
  },
  {
    name: "nome",
    label: t("common.terms.name"),
    field: "name",
    align: "left",
    sortable: true,
  },
  {
    name: "country",
    label: t("ui.navigation.country"),
    field: (row) => row.country.name,
    align: "left",
    sortable: true,
  },
  {
    name: "status",
    label: t("common.terms.status"),
    field: (row) =>
      row.status == "ACTIVE"
        ? t("common.status.active")
        : t("common.status.inactive"),
    align: "left",
    sortable: true,
  },
  {
    name: "actions",
    label: t("common.terms.actions"),
    align: "left",
    required: true,
  },
];

const onRowClick = (row) => {
  if (permission_store.getAccess("config.state", "edit") === false) {
    $q.loading.hide();
    $q.notify({
      type: "negative",
      message: t("validation.permissions.edit"),
    });
    return;
  }
  $q.dialog({
    component: AddEditStateDialog,
    componentProps: {
      state: row,
      title: () =>
        useI18n().t("common.actions.edit") +
        " " +
        useI18n().t("ui.navigation.state"),
    },
  }).onOk(async (success) => {
    if (success) {
      tableRef.value.refresh();
    }
  });
};

const onAddItem = () => {
  if (permission_store.getAccess("config.state", "add") === false) {
    $q.loading.hide();
    $q.notify({
      type: "negative",
      message: t("validation.permissions.add"),
    });
    return;
  }
  $q.dialog({
    component: AddEditStateDialog,
    componentProps: {
      title: () =>
        useI18n().t("common.actions.add") +
        " " +
        useI18n().t("ui.navigation.state"),
    },
  }).onOk(async (success) => {
    if (success) {
      tableRef.value.refresh();
    }
  });
};
</script>
